#!/usr/bin/perl -w
require 5.002;
use Socket;
use CGI qw(:standard);
use crypto;

$config_dir = "/etc/";
$http_dir = "/usr/local/apache/htdocs/passwdd/";

$config_file = $config_dir . "passwdc.conf";
$results_file = $http_dir . "ag_results.html";

$login = param("login");
$target = param("target");
$password = param("password");
$members = param("members");
$administrators = param("administrators");

$port = 1099;
@targets = ("localhost");				# Default value

$final_string = "";

print header();

if ($login eq "") {
	$final_string = "The login field is NOT optional.\n";
	display_result($final_string);
	exit;
}

if ($password eq "") {
	$final_string = "The password field is NOT optional.\n";
	display_result($final_string);
	exit;
}

if ($target eq "") {
	$final_string = "The target field is NOT optional.\n";
	display_result($final_string);
	exit;
}

# Parse config file.
$section = "";
if (open(CONF, "< $config_file")) {
	while (<CONF>) {
		chomp;
		s/^\s*|\s*$//g;					# Remove leading and trailing spaces
												# and tabs.
		if ($_ eq "") {					# Skip empty lines.
			next;
		}
		if (/^[\#\%]/) {					#Skip comments
			next;
		}
		if (/^\[(.*)\]$/) {				# This is a section name because the
												# first character is '[' and the last
												# is ']'.
			$section = $_;
			next;
		}
		@entry = split(/\s*=\s*/); 
# Skip keys only or keys with more than one values.
		if (defined($entry[2]) || !defined($entry[1])) {
			next;
		}
# Here begins program specific section.
		$key_directory = $entry[1] if ((lc($section) eq "[security]") && (lc($entry[0]) eq "key_directory"));
		$port = int($entry[1]) if ((lc($section) eq "[global]") && (lc($entry[0]) eq "port"));
		@targets = split('\s*[,;]\s*', $entry[1]) if ((lc($section) eq "[global]") && (lc($entry[0]) eq "targets"));
	}
	close(CONF);
}

foreach $remote (@targets) {
	if (0 == crypto::RSALoadPublicKey($key_directory . "/" . $remote)) {
		$final_string = $final_string . "Requesting public key from ". $remote . "\n";
		crypto::get_key($remote, $port, $key_directory);
		crypto::RSALoadPublicKey($key_directory . "/" . $remote);
	}

	$iaddr = inet_aton($remote);
	$paddr = sockaddr_in($port, $iaddr);
	$proto = getprotobyname('tcp');

	$final_string = $final_string . "Adding " . $target . " on ". $remote . "\n";
	unless (socket(SOCK, PF_INET, SOCK_STREAM, $proto)) {
		$final_string = $final_string . "Invalid socket call: $!\n";
		next;
	}
	unless (connect(SOCK, $paddr)) {
		$final_string = $final_string . "Invalid connect call: $!\n";
		close(SOCK);
		next;
	}
	if ('+' ne read_byte(SOCK)) {
		$final_string = $final_string . "Invalid response from server.\n";
		close(SOCK);
		next;
	}
	write_string(SOCK, $login);
	crypto::write_password(fileno(SOCK), $password);
	$go_ahead = read_byte(SOCK);
	if ('!' eq $go_ahead) {
		write_byte(SOCK, 'b');
		write_string(SOCK, $target);
		write_string(SOCK, $members);
		write_string(SOCK, $administrators);
		$result = read_byte(SOCK);
		if ('+' eq $result) {
			$final_string = $final_string . "Group successfully added.\n";
		} elsif ('-' eq $result) {
			$final_string = $final_string . "There is already such group on this host.\n";
		} elsif ('*' eq $result) {
			$final_string = $final_string . "Group is not added. Server returned error.\n";
		} elsif ('~' eq $result) {
			$final_string = $final_string . "Access denied.\n";
		} else {
			$final_string = $final_string . "Invalid response from server.\n";
		}
		close(SOCK);
		next;
	}
	if ('^' eq $go_ahead) {
		$final_string = $final_string . "Invalid login.\n";
		close(SOCK);
		next;
	} 
	$final_string = $final_string . "Invalid response from server.\n";
	close(SOCK);
}
display_result($final_string);

sub read_string
{
	$result = "";
	do {
		read($_[0], $c, 1);
		if ($c ne "\0") {
			$result = $result . $c;
		}
	} while ($c ne "\0");
	return $result;
}

sub write_string
{
	$out = $_[1] . "\0";
	return syswrite($_[0], $out, length($out));
}

sub read_byte
{
	read($_[0], $c, 1);
	return $c;
}

sub write_byte
{
	return syswrite($_[0], $_[1], 1);
}

sub display_result
{
	if (open(RESULTS, "< $results_file")) {
		while (<RESULTS>) {
			if (/<!-- Insert result here -->/) {
				$_[0] =~ s/\n/<BR>\n/g;
				printf($_[0]);
			} else {
				printf($_);
			}
		}
		close(RESULTS);
	}	
}