#ifndef __SERVER_HPP__
#define __SERVER_HPP__

void server(int);
bool check_gecos_field(char *);
bool allow_change(char *, char *);
bool allow_change_group(char *, char *);
bool change_password(char *, char *, int, int, int, int);
bool change_gecos(char *, char *, char *, char *, char *, char *);
bool change_password_group(char *, char *);

// function: check_login
// paramters: user name
//            user password
// description: Returns true if the given user exists and has supplied the
//              correct password.

bool check_login(char *, char *);
// function: check_target
// paramters: user name
// description: If shadow password is enabled returns true if the supplied as
//              a parameter user name exists in the /etc/passwd and /etc/shadow
//              databases.
//              If shadow password is disables returns true if the supplied as
//              a parameter user name exists only in the /etc/passwd file
bool check_target(char *);
bool check_target_group(char *);
bool delete_user(char *);
bool delete_group(char *);
bool allow_add(char *);
bool add_user(char *, char *, char *, char *, int, int);
bool add_group(char *, char *, char *);
bool remove_tree(char *);
char *get_group(char *);
void action_delete_group(int, char *);
void action_change_group_password(int, char *, char *);
void action_add_user(int, char *);
void action_getkey(int);
void action_change_password(int, char *, char *);
void action_add_group(int, char *);
void action_delete_user(int, char *);
void action_chfn(int, char *);
void action_get_group(int, char *);
bool check_shell(char *);
bool make_home(char *, char *, int, int);

#endif // __SERVER_HPP__